using System;
using System.Collections;
using System.Web.Script.Serialization;
using System.Web;
using System.Net;
using System.IO;
using System.Text;
using System.Collections.Generic;
using System.Security.Cryptography;
using System.Reflection;

public class TestCourseAdd {
    public static void Main() {
        MTCloud obj = new MTCloud();

        Hashtable options = new Hashtable();

        // ==========创建普通课程==========
        string res = obj.courseAdd("ttt", "10000", "2016-11-21", "2016-11-21 00:30", "aaa", "bbb", options);
        Console.WriteLine(res);
        // ==========创建普通课程==========
        




        // ==========创建关联视频课程==========
        // 上传视频，获取视频ID
        string videoTitle = "test";         // 视频标题
        string nickname = "aaa";            // 主播昵称
        string accountIntro = "bbb";        // 主播简介
        string account = "1test4";          // 主播帐号
        string file = "D:\\test.flv";    // 要上传的视频文件
        string fileMd5 = obj.HashFile(file, "md5").ToLower();

        Hashtable options2 = new Hashtable();
        options2.Add("nickname", nickname);
        options2.Add("accountIntro", accountIntro);

        string result = obj.videoGetUploadUrl(account, MTCloud.ACCOUNT_TYPE_THIRD, videoTitle, fileMd5, options2);

        Console.WriteLine("result");
        Console.WriteLine(result);

        string uploadRes = "";

        Hashtable result2 = (new JavaScriptSerializer()).Deserialize<Hashtable>(result);
        if (MTCloud.CODE_SUCCESS == int.Parse(result2["code"].ToString())) {
            Dictionary<string, object> resultData = (Dictionary<string, object>) result2["data"];

            string uploadUrl = resultData["resumeUploadUrl"].ToString();    // 分段上传地址
            string chunkListUrl = resultData["chunkListUrl"].ToString();    // 获取上传过的分段文件的地址

            // 分段上传
            using (FileStream cutFileStream = new FileStream(file, FileMode.Open)) {
                using (BinaryReader cutFileReader = new BinaryReader(cutFileStream)) {
                    byte[] cutBytes;

                    int cutFileSize = 1048576;
                    int fileCount = Convert.ToInt32(Math.Ceiling((double)cutFileStream.Length / cutFileSize));

                    string chunkListJson = obj.doGet(chunkListUrl);
                    Hashtable chunkListResult = (new JavaScriptSerializer()).Deserialize<Hashtable>(chunkListJson);
                    Object[] chunkList = null;
                    if (MTCloud.CODE_SUCCESS == int.Parse(chunkListResult["code"].ToString())) {
                        chunkList = (Object[]) chunkListResult["data"];
                    }

                    int chunkListLength = 0;
                    if (null != chunkList) {
                        chunkListLength = chunkList.GetLength(0);
                    }

                    for (int i = 0; i < fileCount; i++) {
                        cutBytes = cutFileReader.ReadBytes(cutFileSize);

                        // 传过的分段跳过
                        bool _continue = false;

                        for (int j = 0; j < chunkListLength; j++) {
                            if ((i+1).ToString() == chunkList[j].ToString()) {
                                _continue = true;
                                break;
                            }
                        }

                        if (true == _continue) {
                            continue;
                        }

                        string uploadFileName = Path.GetFileName(file);

                        MD5 md5 = new MD5CryptoServiceProvider();
                        byte[] output = md5.ComputeHash(cutBytes);

                        Hashtable postData = new Hashtable();
                        postData.Add("chunk", (i+1));           // 当前传的是第几分段
                        postData.Add("chunks", fileCount);      // 总的分段数
                        postData.Add("md5", fileMd5);           // 原文件的MD5
                        postData.Add("chunkMd5", BitConverter.ToString(output).Replace("-","").ToLower());      // 分段文件的MD5

                        Hashtable fileDatas = new Hashtable();
                        Hashtable fileObj = new Hashtable();
                        fileObj.Add("fileName", uploadFileName);
                        fileObj.Add("contentType", obj.getContentType(file.Substring(file.LastIndexOf(".") + 1, (file.Length - file.LastIndexOf(".") - 1))));
                        fileObj.Add("content", cutBytes);
                        fileDatas.Add("filedata", fileObj);

                        uploadRes = obj.uploadFileData(uploadUrl, postData, fileDatas);
                    }
                }
            }
        } else if (MTCloud.CODE_VIDEO_UPLOADED == int.Parse(result2["code"].ToString())) {
            // 已经上传过的无需再次上传，直接返回结果
            uploadRes = result;
        }

        Console.WriteLine("uploadRes");
        Console.WriteLine(uploadRes);

        if ("" != uploadRes) {
            Hashtable result3 = (new JavaScriptSerializer()).Deserialize<Hashtable>(uploadRes);

            if (MTCloud.CODE_SUCCESS == int.Parse(result3["code"].ToString()) || MTCloud.CODE_VIDEO_UPLOADED == int.Parse(result3["code"].ToString())) {
                Dictionary<string, object> result3Data = (Dictionary<string, object>) result3["data"];

                var videoId = result3Data["videoId"];

                // 用上传成功的视频创建关联的课程
                Hashtable options3 = new Hashtable();
                options3["relateType"] = MTCloud.APP_TYPE_VIDEO;
                options3["relateId"] = videoId;
                string res3 = obj.courseAdd("test", account, "2017-07-25 14:10", "2017-07-25 22:50", "aaa", "bbb", options3);
                Console.WriteLine(res3);
            }
        }
        // ==========创建关联视频课程==========









        // ==========创建关联回放的课程==========
        Hashtable options4 = new Hashtable();
        options4["relateType"] = MTCloud.APP_TYPE_COURSE;
        options4["relateId"] = 29673;        // 关联的课程ID
        string res4 = obj.courseAdd("test", "testaaqd5", "2017-07-25 14:10", "2017-07-25 22:50", "aaa", "bbb", options4);
        Console.WriteLine(res4);
        // ==========创建关联回放的课程==========
    }
}


























